apt install borgbackup
 
borg init --encryption=repokey /path/to/repo
 
# Example usage to create backups:
borg create /path/to/repo::Monday $HOME/src $HOME/Documents
borg create --stats /path/to/repo::Tuesday $HOME/src $HOME/Documents
 
# What I use
# Store backups on webserver
# I backup my vault shiny & zettel
borg list ssh://server/$HOME/backups
 
# And in a crontab:
30 14 * * * $HOME/.snippets/sh/backup.sh

Script taken from the documentation, customized to my situation (Status: 2023-03-28)

#!/bin/sh
 
# Setting this, so the repo does not need to be given on the commandline:
export BORG_REPO=ssh://rserv/home/lukeg/backups
 
# See the section "Passphrase notes" for more infos.
export BORG_PASSPHRASE='<PASSPHRASE>'
 
# some helpers and error handling:
info() { printf "\n%s %s\n\n" "$( date )" "$*" >&2; }
trap 'echo $( date ) Backup interrupted >&2; exit 2' INT TERM
 
info "Starting backup"
 
# Backup the most important directories into an archive named after
# the machine this script is currently running on:
 
borg create                         \
    --verbose                       \
    --filter AME                    \
    --list                          \
    --stats                         \
    --progress                      \
    --show-rc                       \
    --compression lz4               \
    --exclude-caches                \
    --exclude '*.git/*'             \
                                    \
    ::'shiny-{now:%Y-%m-%d}'        \
    $HOME/shiny 2>> $HOME/.logs/notes-backup.log
 
borg create                         \
    --verbose                       \
    --filter AME                    \
    --list                          \
    --stats                         \
    --progress                      \
    --show-rc                       \
    --compression lz4               \
    --exclude-caches                \
    --exclude '*.git/*'             \
                                    \
    ::'zettel-{now:%Y-%m-%d}'        \
    $HOME/zettel 2>> $HOME/.logs/notes-backup.log
 
backup_exit=$?
 
info "Pruning repository"
 
# Use the `prune` subcommand to maintain 7 daily, 4 weekly and 6 monthly
# archives of THIS machine. The '{hostname}-*' matching is very important to
# limit prune's operation to this machine's archives and not apply to
# other machines' archives also:
 
borg prune                          \
    --list                          \
    --show-rc                       \
    --keep-daily    7               \
    --keep-weekly   4               \
    --keep-monthly  6               \
    2>> $HOME/.logs/notes-backup.log
 
prune_exit=$?
 
# actually free repo disk space by compacting segments
 
info "Compacting repository"
 
borg compact 2>> $HOME/.logs/notes-backup.log
 
compact_exit=$?
 
# use highest exit code as global exit code
global_exit=$(( backup_exit > prune_exit ? backup_exit : prune_exit ))
global_exit=$(( compact_exit > global_exit ? compact_exit : global_exit ))
 
if [ ${global_exit} -eq 0 ]; then
    info "Backup, Prune, and Compact finished successfully"
elif [ ${global_exit} -eq 1 ]; then
    info "Backup, Prune, and/or Compact finished with warnings"
else
    info "Backup, Prune, and/or Compact finished with errors"
fi
 
exit ${global_exit}